#ifndef KEXEC_LOONGARCH_H
#define KEXEC_LOONGARCH_H

#include <sys/types.h>

#define BOOT_BLOCK_VERSION 17
#define BOOT_BLOCK_LAST_COMP_VERSION 16

#define MAX_MEMORY_RANGES  64
#define MAX_LINE          160

#define CORE_TYPE_ELF32 1
#define CORE_TYPE_ELF64 2

#define COMMAND_LINE_SIZE	512

#define KiB(x) ((x) * 1024UL)

int elf_loongarch_probe(const char *buf, off_t len);
int elf_loongarch_load(int argc, char **argv, const char *buf, off_t len,
	struct kexec_info *info);
void elf_loongarch_usage(void);
int is_crashkernel_mem_reserved(void);
int get_crash_kernel_load_range(uint64_t *start, uint64_t *end);
int loongarch_load_dtb_segment(struct kexec_info *info, unsigned long hole_min,
	unsigned long initrd_base, unsigned long initrd_size, char *command_line);


struct arch_options_t {
	char *command_line;
	char *initrd_file;
	char *dtb;
	int core_header_type;
};

extern struct memory_ranges usablemem_rgns;
extern struct arch_options_t arch_options;
extern off_t initrd_base, initrd_size;

#endif /* KEXEC_LOONGARCH_H */
